#include <iostream>
#include <vector>
#include <queue>
#include <cstdlib>
using namespace std;

int V, E;
bool vis[10001] = {0};
int parent[10001] = {0};
int dist[10001] = {0};
vector<int> G[10001];

int max_v, max_d;

void bfs(int s)
{
  max_v = s; max_d = 0;
  queue<int> Q;
  vis[s] = true;
  Q.push(s);
  while(!Q.empty())
  {
    int v = Q.front(); Q.pop();
    for(int i=0; i<(int)G[v].size(); i++)
    {
      int k = G[v][i];
      if(!vis[k])
      {
        vis[k] = true;
        dist[k] = dist[v]+1;
        if(dist[k]>max_d)
        {
          max_d = dist[k];
          max_v = k;
        }
        Q.push(k);
      }
    }
  }
}

int main()
{
  ios_base::sync_with_stdio(0);
  cin >> V;
  for(int i=0; i<V-1; i++)
  {
    int a, b;
    cin >> a >> b;
    G[a].push_back(b);
    G[b].push_back(a);
  }
  bfs(1);
  fill(vis, vis+10001, false);
  fill(dist, dist+10001, 0);
  bfs(max_v);
  cout << max_d << '\n';
  return 0;
}
